#include "aboutbox.h"
#include "window.h"

extern "C"
{
 #include "interface.h"
}

namespace sudoku
{

void
on_about_button_clicked(GtkButton*, gpointer user_data)
{
  const AboutBox *aboutBox = static_cast<const AboutBox*>(user_data);
  aboutBox->hide();
}


void
on_aboutbox_delete(GtkWidget*, GdkEvent*, gpointer user_data)
{
  const AboutBox *aboutBox = static_cast<const AboutBox*>(user_data);
  aboutBox->hide();
}


/*********************************************************************
 */
AboutBox::AboutBox(Window *w)
  : Component(w, create_aboutbox())
{
  GtkWidget *aboutButton = lookup_widget( getGtkWidget(), "about_button" );
  g_signal_connect(static_cast<gpointer>(aboutButton),
                   "clicked",
                   G_CALLBACK(on_about_button_clicked),
                   this);

  g_signal_connect(getGtkWidget(),
                   "delete_event",
                   G_CALLBACK(on_aboutbox_delete),
                   this);
}


/*********************************************************************
 */
AboutBox::~AboutBox()
{
  gtk_widget_destroy( getGtkWidget() );
}

}

