#ifndef FREEDOM_H
#define FREEDOM_H

#include <iostream>
#include <list>

#include "bitmask.h"

namespace sudoku
{
  class Sequence;

  typedef std::list<Subset>  SubsetCollection;

  class Freedom
  {
  public:
    typedef unsigned  size_type;

  private:
    const size_type m_size;
    Bitmask *m_bitmask;

    Sequence *m_sequence;

  public:
    explicit Freedom(Sequence*);
    ~Freedom();

    const Bitmask& operator[](size_type i) const {
        TRACE( if (i < size()) ; else abort();  )
        return m_bitmask[i];
    }
    Bitmask& operator[](size_type i) {
        TRACE( if (i < size()) ; else abort();  )
        return m_bitmask[i];
    }

    size_type size() const { return m_size; }
    Sequence* getSequence() const { return m_sequence; }

    bool findNumberSubsets(SubsetCollection&) const;
  };
}

namespace std
{
  ostream& operator<<(ostream&, const sudoku::Freedom&);
}

#endif
